---
title: WebAssembly.Memory() constructor
slug: Web/JavaScript/Reference/Global_Objects/WebAssembly/Memory/Memory
tags:
  - Constructor
  - JavaScript
  - Reference
  - WebAssembly
---
<div>{{JSRef}}</div>

<p>The <code><strong>WebAssembly.Memory()</strong></code> constructor creates a new <code>Memory</code> object whose {{jsxref("WebAssembly/Memory/buffer","buffer")}} property is a resizable <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer">ArrayBuffer</a></code> or <code>SharedArrayBuffer</code> that holds the raw bytes of memory accessed by a WebAssembly <code>Instance</code>.</p>

<p>A memory created by JavaScript or in WebAssembly code will be accessible and mutable from both JavaScript and WebAssembly.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new WebAssembly.Memory(memoryDescriptor);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em>memoryDescriptor</em></dt>
 <dd>An object that can contain the following members:
 <dl>
  <dt><em>initial</em></dt>
  <dd>The initial size of the WebAssembly Memory, in units of WebAssembly pages.</dd>
  <dt><em>maximum {{optional_inline}}</em></dt>
  <dd>The maximum size the WebAssembly Memory is allowed to grow to, in units of WebAssembly pages. When present, the <code>maximum</code> parameter acts as a hint to the engine to reserve memory up front. However, the engine may ignore or clamp this reservation request. Unshared WebAssembly memories don't need to set a <code>maximum</code>, but shared memories do.</dd>
  <dt>shared <em>{{optional_inline}}</em></dt>
  <dd>A boolean value that defines whether the memory is a shared memory or not. If set to <code>true</code>, it is a shared memory. The default is <code>false</code>.</dd>
 </dl>
 </dd>
</dl>

<div class="note">
<p><strong>Note</strong>: A WebAssembly page has a constant size of 65,536 bytes, i.e., 64KiB.</p>
</div>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>If <code>memoryDescriptor</code> is not of type object, a {{jsxref("TypeError")}} is thrown.</li>
 <li>If <code>maximum</code> is specified and is smaller than <code>initial</code>, a {{jsxref("RangeError")}} is thrown.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_new_Memory_instance">Creating a new Memory instance</h3>

<p>There are two ways to get a <code>WebAssembly.Memory</code> object. The first way is to construct it from JavaScript. The following example creates a new WebAssembly Memory instance with an initial size of 10 pages (640KiB), and a maximum size of 100 pages (6.4MiB). Its <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/WebAssembly/Memory/buffer">buffer</a></code> property will return an <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer">ArrayBuffer</a></code>.</p>

<pre class="brush: js notranslate">var memory = new WebAssembly.Memory({initial:10, maximum:100});</pre>

<p>The second way to get a <code>WebAssembly.Memory</code> object is to have it exported by a WebAssembly module. The following example (see <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/memory.html">memory.html</a> on GitHub, and <a href="https://mdn.github.io/webassembly-examples/js-api-examples/memory.html">view it live also</a>) fetches and instantiates the loaded memory.wasm byte code using the {{jsxref("WebAssembly.instantiateStreaming()")}} method, while importing the memory created in the line above. It then stores some values in that memory, then exports a function and uses it to sum some values.</p>

<pre class="brush: js notranslate">WebAssembly.instantiateStreaming(fetch('memory.wasm'), { js: { mem: memory } })
.then(obj =&gt; {
  var i32 = new Uint32Array(memory.buffer);
  for (var i = 0; i &lt; 10; i++) {
    i32[i] = i;
  }
  var sum = obj.instance.exports.accumulate(0, 10);
  console.log(sum);
});</pre>

<h3 id="Creating_a_shared_memory">Creating a shared memory</h3>

<p>By default, WebAssembly memories are unshared. You can create a <a href="/en-US/docs/WebAssembly/Understanding_the_text_format#Shared_memories">shared memory</a> by passing <code>shared: true</code> in the constructor's initialization object:</p>

<pre class="notranslate">let memory = new WebAssembly.Memory({initial:10, maximum:100, shared:true});</pre>

<p>This memory's <code>buffer</code> property will return a <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/SharedArrayBuffer">SharedArrayBuffer</a></code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAssembly JS', '#dom-memory-memory', 'Memory')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.WebAssembly.Memory.Memory")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/WebAssembly">WebAssembly</a> overview page</li>
 <li><a href="/en-US/docs/WebAssembly/Concepts">WebAssembly concepts</a></li>
 <li><a href="/en-US/docs/WebAssembly/Using_the_JavaScript_API">Using the WebAssembly JavaScript API</a></li>
</ul>
